/*
 Copyright (c) 2002 Amduus Information Works, Inc.  
 scott_auge@yahoo.com sauge@amduus.com

 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the "Software"),
 to deal in the Software without restriction, including without limitation the
 rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 sell copies of the Software, and to permit persons to whom the Software
 is furnished to do so, subject to the following conditions:
 
 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
 KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 DEALINGS IN THE SOFTWARE.
*/ 

/********************************************************************/
/* Define your function here                                        */
/********************************************************************/

/* Sample function with two arguments */

FUNCTION Power RETURNS CHARACTER (INPUT cArgs AS CHARACTER):

  DEF VAR cArg1 AS CHARACTER NO-UNDO.
  DEF VAR cArg2 AS CHARACTER NO-UNDO.

  DEF VAR dResult AS DECIMAL NO-UNDO.

  /* Args come in a single string delimited with , */

  ASSIGN cArg1 = ENTRY (1, cArgs)
         cArg2 = ENTRY (2, cArgs).

  /* Do your computation */

  ASSIGN dResult = EXP(DECIMAL(cArg1), DECIMAL(cArg2)).

  /* Return a string! */

  RETURN STRING (dResult).

END. /* FUNCTION Power */


/********************************************************************/
/* Add your function to be evaluated here.                          */
/********************************************************************/

FUNCTION FuncEval RETURNS CHARACTER (INPUT cExpression AS CHARACTER ):

  DEF VAR cSubExpression       AS CHARACTER NO-UNDO.
  DEF VAR iSubExpressionIndex  AS INTEGER NO-UNDO.
  DEF VAR cReplaceExpression   AS CHARACTER NO-UNDO.
  DEF VAR cArgExpression       AS CHARACTER NO-UNDO.
  DEF VAR cEvalExpression      AS CHARACTER NO-UNDO.

  /* We always evalute functions from the right to the left */
  /* to make sure they are evaluted according to algebraic  */
  /* rules.  We repeat to make sure we get em all!          */
  /* To add your own function:                              */
  /*   1) Create a function as above                        */
  /*   2) Determine the name of the function in the expres- */
  /*      sion                                              */
  /*   3) Add AlgFuncTemplate.i  First argument is the ex-  */
  /*      pression name, the second is the function name in */
  /*      in your code.                                     */

  /******************* Begin Example Template *******************/

  {AlgFuncTemplate.i Power Power}

  /******************* End Example Template *******************/

  RETURN cExpression.

END.


