/*
 Copyright (c) 2002 Amduus Information Works, Inc.  
 scott_auge@yahoo.com sauge@amduus.com
 
 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the "Software"),
 to deal in the Software without restriction, including without limitation the
 rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 sell copies of the Software, and to permit persons to whom the Software
 is furnished to do so, subject to the following conditions:
 
 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
 KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN            
 CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 DEALINGS IN THE SOFTWARE.
*/ 

/* Arg1 is the name of the function in the expression */
/* Arg 2 is the name of the function definition in code */

  REPEAT:

    ASSIGN iSubExpressionIndex = R-INDEX(cExpression, "{1}" + "[").

    IF iSubExpressionIndex > 0 THEN DO:

      /* Pull out the sub expression we are going to replace */
      /* with the results.                                   */

      ASSIGN cSubExpression = SUBSTRING(cExpression, iSubExpressionIndex).
      ASSIGN cReplaceExpression = SUBSTRING(cSubExpression, 1, INDEX(cSubExpression, "]")).

      /* Pull out the arguments to the function */

      ASSIGN cArgExpression =
        SUBSTRING(cReplaceExpression, INDEX(cReplaceExpression, "[") + 1).
      ASSIGN cArgExpression =
        SUBSTRING(cArgExpression, 1, INDEX(cArgExpression, "]") - 1).

      /* Call the defined function */

      ASSIGN cEvalExpression = {2} (cArgExpression).

      /* Replace the expression with the evaluation */

     ASSIGN cExpression = REPLACE(cExpression, cReplaceExpression, cEvalExpression).

    END. /* Found one! */
    ELSE LEAVE.

  END. /* REPEAT: */

