
DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/PDFClt/RCS/PDFSvrPut.p,v 1.1 2002/07/11 20:15:41 sauge Exp $" NO-UNDO.

DEF INPUT PARAMETER cFileName      AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cPDFReportID  AS CHARACTER NO-UNDO.

DEF VAR cOSFileID  AS CHARACTER NO-UNDO.
DEF VAR cError     AS CHARACTER NO-UNDO.

{MakeID3.i}
{FileName.i}
{FilePath.i}

/* Load the file into the Progress DB and aquire an OSFileID */

RUN file/StoreFile.p
(INPUT FileName(cFilename),
 INPUT FilePath(cFileName),
 INPUT "PDFReport",
 OUTPUT cOSFileID,
 OUTPUT cError).

/* Create a PDFReport record to store it in and let the PDF Server know it */
/* needs to be processed.                                                  */

CREATE PDFReport.

ASSIGN PDFReport.PDFReportID = MakeID3(10).

ASSIGN
PDFReport.InOSFileID = cOSFileID
PDFReport.ReportStatus = "SUBMITTED"
PDFReport.CreateDate = TODAY
PDFReport.CreateTime = TIME.

ASSIGN cPDFReportID = PDFReport.PDFReportID.

RELEASE PDFReport.

