
DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/PDFClt/RCS/PDFSvrWatch.p,v 1.1 2002/07/11 20:15:41 sauge Exp $" NO-UNDO.

DEF INPUT PARAMETER cPDFReportID   AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cReportStatus AS CHARACTER NO-UNDO.

FIND PDFReport NO-LOCK
WHERE PDFReport.PDFReportID = cPDFReportID
NO-ERROR NO-WAIT.

IF LOCKED PDFReport THEN DO:

  ASSIGN cReportStatus = "LOCKED".
  RETURN.

END.

IF NOT AVAILABLE PDFReport THEN DO:

  ASSIGN cReportStatus = "NO_RECORD".
  RETURN.

END.

ASSIGN cReportStatus = PDFReport.ReportStatus.

RELEASE PDFReport.

