

/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/rptgen/RCS/Drill.p,v 3.0 2003/06/25 07:12:41 sauge Exp $" NO-UNDO. 

/* Note this is a Webspeed requirement! */
{src/web/method/wrap-cgi.i}

/* Blue Diamond - untested here */
/* {sga_util.i} */


/* Find @drill() macros */

DEF INPUT PARAMETER cS AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cT AS CHARACTER NO-UNDO.

DEF VAR cB         AS CHARACTER NO-UNDO.
DEF VAR cSub       AS CHARACTER NO-UNDO.
DEF VAR cRptName   AS CHARACTER NO-UNDO.
DEF VAR cRptArgs   AS CHARACTER NO-UNDO.
DEF VAR cTarget    AS CHARACTER NO-UNDO.
DEF VAR cLinkText  AS CHARACTER NO-UNDO.
DEF VAR cRptArgURL AS CHARACTER NO-UNDO.
DEF VAR cOut       AS CHARACTER NO-UNDO.

DEF VAR i AS INTEGER NO-UNDO.
 
ASSIGN cT = cS.
  
REPEAT:
      
    /* If there is no holder, then leave */
     
   IF INDEX (cT, "@drill(") = 0 THEN LEAVE.
     
   /* We found one - chop out the arguments and go run things */
   /* It is the right one, pull out the contents between  */
   /* the ( and ) characters.                             */
     
   ASSIGN cB = SUBSTRING (cT, INDEX (cT, "@drill(") + 7).
          cB = SUBSTRING (cB, 1, INDEX(cB, ")") - 1).

   ASSIGN cRptName  = ENTRY(1, cB).
   ASSIGN cRptArgs  = ENTRY(2, cB).
   ASSIGN cTarget   = ENTRY(3, cB).
   ASSIGN cLinkText = ENTRY(4, cB).

   FIND RptTemplate1 NO-LOCK
   WHERE RptTemplate1.Name = cRptName
   NO-ERROR.

   IF NOT AVAILABLE RptTemplate1 THEN LEAVE.

   DO i = 1 TO NUM-ENTRIES(cRptArgs,"|"):

     ASSIGN cRptArgURL = cRptArgURL
                       + TRIM(STRING(i,">9"))
                       + "="
                       + URL-ENCODE(ENTRY(i,cRptArgs,"|"), "query") /* Webspeed */
                       + "&".

   END.

   ASSIGN cRptArgURL = cRptArgURL 
                     + "NumberInputs="
                     + TRIM(STRING(NUM-ENTRIES(cRptArgs,"|"),">9"))
                     + "&RptTemplate1ID="
                     + RptTemplate1.RptTemplate1ID.

   ASSIGN cOut = "<a href=~"HTMLRpt.html?"
               + cRptArgURL
               + "~""
               + " target=~""
               + cTarget
               + "~">"
               + cLinkText
               + "</a>".

   /* We don't want the macro to remain in the report text! */

   ASSIGN cSub = "@drill(" + cB + ")".
   ASSIGN cT = REPLACE (cT, cSub, cOut).

END. /* REPEAT: */


