
&IF DEFINED(SCALEDATA_I) <> 1 &THEN
&GLOBAL-DEFINE SCALEDATA_I YEP

DEF VAR SCALEDATA_I_RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/RCS/ScaleData.i,v 3.0 2003/06/25 07:14:01 sauge Exp sauge $" NO-UNDO.

{PullLastChar.i}

/* Should work with INT and REAL numbers implicitly. */

FUNCTION ScaleData RETURNS CHARACTER (INPUT cDataList AS CHARACTER):

  DEF VAR iCurrentEntry   AS INTEGER NO-UNDO.
  DEF VAR iNumberEntry    AS INTEGER NO-UNDO.
  DEF VAR iMaxEntry       AS INTEGER NO-UNDO.
  DEF VAR fCurrentValue   AS DECIMAL NO-UNDO.
  DEF VAR fRatioValue     AS DECIMAL NO-UNDO.
  DEF VAR cRatioList      AS CHARACTER NO-UNDO.
  DEF VAR fGreatestFound  AS DECIMAL NO-UNDO.

  ASSIGN iNumberEntry = NUM-ENTRIES(cDataList).

  /* Determine the greatest divisor we are going to use to translate */
  /* values between 0.0 and 1.0 for scaling using the *BarChart.i    */
  /* routines.                                                       */

  DO iCurrentEntry = 1 TO iNumberEntry:

    ASSIGN fCurrentValue = DECIMAL(ENTRY(iCurrentEntry, cDataList)).

    IF fCurrentValue > fGreatestFound THEN 
      ASSIGN fGreatestFound = fCurrentValue.

  END. /* DO iCurrentEntry = 1 TO iNumberEntry */

  /* Create the ratio list to return back to the calling routine */

  DO iCurrentEntry = 1 TO iNumberEntry:

    ASSIGN fCurrentValue = DECIMAL(ENTRY(iCurrentEntry, cDataList)).

    ASSIGN cRatioList = cRatioList 
                      + STRING(fCurrentValue / fGreatestFound)
                      + ",".

  END. /* DO iCurrentEntry = 1 TO iNumberEntry */

  ASSIGN cRatioList = PullLastChar(cRatioList).

  RETURN cRatioList.

END. /* FUNCTION ScaleBarData */

&ENDIF

