

/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/rptgen/RCS/IDFields.p,v 3.0 2003/06/25 07:12:41 sauge Exp $" NO-UNDO. 

  DEF INPUT PARAMETER cTemplate    AS CHARACTER NO-UNDO.
  DEF OUTPUT PARAMETER cFieldList  AS CHARACTER NO-UNDO.

  DEF VAR cFieldName AS CHARACTER NO-UNDO.
  DEF VAR cFieldChar AS CHARACTER NO-UNDO.
  DEF VAR iOffset    AS INTEGER NO-UNDO.
  DEF VAR i          AS INTEGER NO-UNDO.

  /* Look for an entry of @fld( in the template */

  ASSIGN iOffset = INDEX (cTemplate, "@fld(").
  IF iOffset = 0 THEN RETURN.
  ELSE iOffset = iOffset + 5.

  RUN rptgen/IDFields.p 
  (INPUT SUBSTRING(cTemplate, iOffset), 
   OUTPUT cFieldList
  ).

  /* Move on from the @fld( to the ) on the other side */

  DO i = iOffset TO LENGTH (cTemplate):

    ASSIGN cFieldChar = SUBSTRING (cTemplate, i, 1).
    IF cFieldChar = ")" THEN LEAVE.
    ASSIGN cFieldName = cFieldName + cFieldChar.

  END. /* DO i = iOffset TO LENGTH (cTemplate - iOffset) */

  IF NOT CAN-DO (cFieldList, cFieldName) THEN
    ASSIGN cFieldList = cFieldList + "," + cFieldName.

  IF SUBSTRING(cFieldList, 1, 1) = "," THEN
    ASSIGN cFieldList = SUBSTRING(cFieldList, 2).
