
/* c is the full expression */
/* m is the macro name we are gonna pull the args out of */

FUNCTION MacroArg RETURNS CHARACTER 
(INPUT c AS CHARACTER,
 INPUT m AS CHARACTER):

  DEF VAR i AS INTEGER NO-UNDO.  /* where we at?*/
  DEF VAR j AS INTEGER NO-UNDO.  /* count up ( */
  DEF VAR k AS INTEGER NO-UNDO.  /* count up ) */
  DEF VAR a AS CHARACTER NO-UNDO. /* argument to macro */
  DEF VAR b AS CHARACTER NO-UNDO. /* cur working letter */

  ASSIGN i = INDEX (c, m).

  IF i = 0 THEN RETURN c.

  ASSIGN i = i + LENGTH(m) - 1.

  /* Some macros, like calc, may have nested ().  This will count */
  /* up ( and ) and when they match, we have reached the end.     */

  REPEAT:
    ASSIGN i = i + 1.
    ASSIGN b = SUBSTRING(c,i,1).
    IF b = "(" THEN ASSIGN j = j + 1.
    IF b = ")" THEN ASSIGN k = k + 1.
    ASSIGN a = a + SUBSTRING(c,i,1).
    IF j = k THEN LEAVE.
  END.

  /* Pull off the initial (  and trailing ) */
  ASSIGN a = SUBSTRING(a, 2, LENGTH(a) - 2).

  RETURN a.

END.

